#include <stdint.h>
typedef uint64_t u64;
typedef uint32_t u32;
typedef uint16_t u16;
typedef uint8_t u8;

static inline u32 rol32(u32 word, unsigned int shift)
{
	return (word << shift) | (word >> (32 - shift));
}

struct __una_u32 { u32 x __attribute__((packed)); };

static inline u32 __get_unaligned_cpu32(const void *p)
{
	const struct __una_u32 *ptr = (const struct __una_u32 *)p;
	return ptr->x;
}

#ifdef JHASH2
#include "jhash2.h"
#define	hashbfn		jhash
#define hashwfn		jhash2
#else
#include "jhash3.h"
#define	hashbfn		jhash3
#define	hashwfn		jhash32
#endif

#ifdef HASH_BYTE
u32 hash(const void *key, u32 len, u32 initval)
{
	return hashbfn(key, len, initval);
}
#else
u32 hash(const u32 *key, u32 len, u32 initval)
{
	return hashwfn(key, len, initval);
}
#endif
